import numpy as np
#from scipy.ndimage import gaussian_filter
from fspecial import fspecial_gaussian_2d

def bilateral2d(img, radius, sigma, sigmaIntensity):
    pad = radius
    # Initialize filtered image to 0
    out = np.zeros_like(img)

    # Pad image to reduce boundary artifacts
    imgPad = np.pad(img, pad)

    # Smoothing kernel, gaussian with standard deviation sigma
    # and size (2*radius+1, 2*radius+1)
    filtSize = (2*radius + 1, 2*radius + 1)
    spatialKernel = fspecial_gaussian_2d(filtSize, sigma)
    for y in range(img.shape[0]):
        for x in range(img.shape[1]):
            patchVals = imgPad[y+pad-radius:y+pad+radius+1, x+pad-radius:x+pad+radius+1]
            centerVal = imgPad[y+pad, x+pad]
            intensityWeights = np.exp(-((patchVals - centerVal) ** 2) / (2*sigmaIntensity**2))
            #print(spatialKernel.shape)
            #print(intensityWeights.shape)
            #intensityWeights = np.reshape(intensityWeights, spatialKernel.shape)
            weights = spatialKernel * intensityWeights / np.sum(spatialKernel * intensityWeights)
            out[y, x] = np.sum(patchVals * weights)
    return out
