"""
Requires pip install bm3d
"""
import numpy as np
import os
from split_vid import *
#from add_noise import *
#from denoise import *
#from stitch_vid import *
from psnr import *

video = input("Type demo1: ")
#video = input("Which video: plane, beach, brunch, or test? ")
# num = input("How many frames do you want? ")

# Possible Video Options: plane_vid, beach_vid, food_vid, or test_vid
folder_name = video + "_vid"
cwd = os.getcwd()
vid_path = cwd + "/" + folder_name
os.chdir(vid_path)

if video == "test":
    vid_name = video + ".mp4"
else:
    vid_name = video + ".mov"

#sigma = 0.1
sigma = 0.5
#sigma = 1
# num = 1

#Seperate chosen video into frames
print("Extracting frames...")
num = FrameCapture(vid_name)

#Add noise to the video frames
print("Adding noise...")
#psf = AddNoise(sigma, num)
AddNoise(sigma, num)

#Denoise the frames
print("DENOISING TIME!!")
print("Executing Gaussian Filtering...")
Execute_Gauss(num, sigma)
print("Executing Bilateral Filtering...")
Execute_Bilateral(num, sigma)
print("Executing the NonLocal Means Algorithm...")
Execute_NonLocal(num, sigma)
print("Executing BM3D...")
Execute_BM3D(num, sigma)

#Check PSNRs
print("\nPSNR CALCULATIONS:")
#noisy_psnr, noisy_ssim = STATS(num, "noisy")
print("Noisy PSNR = ", noisy_psnr)
print("Noisy Avg PSNR = ", noisy_ssim)
#gauss_psnr, gauss_ssim = STATS(num, "gauss")
print("Local Gaussian Filtering PSNR = ", gauss_psnr)
print("Local Gaussian Filtering Avg PSNR = ", gauss_ssim)
#bilateral_psnr, bilateral_ssim = STATS(num, "bilateral")
print("Local Bilateral Filtering PSNR = ", bilateral_psnr)
print("Local Bilateral Filtering Avg PSNR = ", bilateral_ssim)
#nonlocal_psnr, nonlocal_ssim = STATS(num, "nonlocal")
print("NonLocal Means Algorithm PSNR = ", nonlocal_psnr)
print("NonLocal Means Algorithm Avg PSNR = ", nonlocal_ssim)
#bm3d_psnr, bm3d_ssim = STATS(num, "bm3d")
print("BM3D PSNR = ", bm3d_psnr)
print("BM3D Avg PSNR = ", bm3d_ssim)
print("\n")

#Stitch the frames back into a video
print("Reassembling videos...")
#generate_video(num, "bm3d")
#generate_video(num, "gauss")
#generate_video(num, "bilateral")
#generate_video(num, "nonlocal")

fig, axs = plt.subplots(2, 3, figsize = (15,5))     #Sets subplot size formatting
show = ("frame1.png")
img = cv2.imread(show).astype(float)/255
axs[0,1].imshow(img, cmap='gray')
axs[0,1].set_title('Clean Frame')
show = ("noisyframe1.png")
img = cv2.imread(show).astype(float)/255
axs[0,1].imshow(img, cmap='gray')
axs[0,1].set_title('Noisy Frame, PSNR=' + str(noisy_psnr))
show = ("gauss_denoisedframe1.png")
img = cv2.imread(show).astype(float)/255
axs[0,2].imshow(img, cmap='gray')
axs[0,2].set_title('Gaussian, PSNR=' + str(gauss_psnr))
show = ("bilateral_denoisedframe1.png")
img = cv2.imread(show).astype(float)/255
axs[0,3].imshow(img, cmap='gray')
axs[0,3].set_title('Bilateral, PSNR=' + str(bilateral_psnr))
show = ("nonlocal_denoisedframe1.png")
img = cv2.imread(show).astype(float)/255
axs[0,4].imshow(img, cmap='gray')
axs[0,4].set_title('NonLocal, PSNR=' + str(nonlocal_psnr))
show = ("bm3d_denoisedframe1.png")
img = cv2.imread(show).astype(float)/255
axs[0,5].imshow(img, cmap='gray')
axs[0,5].set_title('BM3D, PSNR=' + str(bm3d_psnr))

#fig.suptitle('deno', fontsize='large', weight='bold')
plt.show()
    


print("FINISHED :)")